# -*- coding: utf-8; -*-
"""
Rattail Demo config extension
"""

from rattail.config import ConfigExtension


class DemoConfigExtension(ConfigExtension):
    """
    Rattail Demo config extension
    """
    key = 'rattail-demo'

    def configure(self, config):

        config.setdefault('rattail', 'app_package', 'rattail_demo')

        # tell rattail where our stuff lives
        config.setdefault('rattail', 'model', 'rattail_demo.db.model')
        config.setdefault('rattail.trainwreck', 'model', 'rattail.trainwreck.db.model.defaults')
        config.setdefault('rattail.mail', 'emails', 'rattail_demo.emails')
        config.setdefault('tailbone', 'menus', 'rattail_demo.web.menus')

        # default app handlers
        config.setdefault('rattail', 'products.handler', 'rattail_corepos.products:CoreProductsHandler')

        # default import handlers
        config.setdefault('rattail.importing', 'versions.handler', 'rattail_demo.importing.versions:FromRattailDemoToRattailDemoVersions')
        config.setdefault('rattail.importing', 'corepos_api.handler', 'rattail_demo.importing.corepos_api:FromCOREPOSToRattail')
